var HTML5DemoComboboxElementWrapper;

(function ()
{
	/* This HTML5 demo combobox control is used to demonstrate how an IEC enumeration can be used in a combobox.
	* This example demonstrates how to get a type information (getTypeDesc) from a variable.
	* It demonstrates also how colors and fonts are transfered and how thay can be used. */
	HTML5DemoComboboxElementWrapper = function()
	{
        this.domNode = document.createElement("div");
        this.combobox = document.createElement("select");
        this.domNode.appendChild(this.combobox);
		this.domNode.style.width = "100%";
		this.domNode.style.height = "100%";
		document.body.appendChild(this.domNode);
		
		var self = this;
		this.combobox.onchange = function() {
			var selectedValue = this.options[this.selectedIndex].value;
			if (self.typeDesc !== undefined)
			{
				var index = 0, valueToWrite, enumValues;
				enumValues = self.typeDesc.EnumValues; 
				for(var key in enumValues) 
				{
					if (index === parseInt(selectedValue))
						valueToWrite = enumValues[key];
					index++;
				}
				if (window.CDSWebVisuAccess.checkSimpleValue('setValue', valueToWrite))
					self.sendValue(valueToWrite);
			}
		}
		
	};
		
	HTML5DemoComboboxElementWrapper.prototype =
	{
		
		sendValue: function(value)
		{
			window.CDSWebVisuAccess.sendSimpleValue('setValue',value);
		},
		
		setTypeDesc: function(typeDesc)
		{
			if (typeDesc !== 0 && typeDesc.EnumValues !== undefined)
			{
				var index = 0;
				this.typeDesc = typeDesc;
				for(var key in typeDesc.EnumValues) 
				{
					this.combobox.options[index] = new Option(key, index);
					index++;
				}
				this.selectCombobox();
			}
		},
		
		selectCombobox: function()
		{
			if (this.typeDesc !== 0 && this.typeDesc.EnumValues !== undefined)
			{
				var enumValues = this.typeDesc.EnumValues, index = 0; 
				for(var key in enumValues) 
				{
					var enumValue = enumValues[key];
					if (enumValue === this._enumValue)
						this.combobox.selectedIndex = index;
					index++;
				}
			}
		},
		
		setValue: function(value, type, typeid)
		{
			this._enumValue = value;
			if (this.typeDesc === undefined)
			{
				var self = this;
				var result = window.CDSWebVisuAccess.getTypeDesc(typeid);
				result.then(function(value) 
				{
					self.setTypeDesc(value);
				}, function(value) {
					self.setTypeDesc(value);
				});
			}
			else
				this.selectCombobox();
		},
		
		setBackgroundColor: function(value, type, typeid)
		{
			this.combobox.style.backgroundColor = value;
		},
		setForegroundColor: function(value, type, typeid)
		{
			this.combobox.style.foregroundColor = value;
		},
		setFont: function(value, type, typeid)
		{
			this.combobox.style.font = value.Font;
			this.combobox.style.color = value.Color;
		},
		setEnabled: function(value, type, typeid)
		{
			this.combobox.disabled = !value;
		}
	
	};
}());

