var HTML5DemoImageElementWrapper ;

(function ()
{
	/* This HTML5 demo image control is used to demonstrate how images can be used in a HTML5 control.*/
	HTML5DemoImageElementWrapper  = function()
	{
		this.domNode = document.createElement("div");
		this.domNode.id = "img";
		this.domNode.style.width = "100%";
		this.domNode.style.height = "100%";
		this.domNode.style.overflow = "hidden";
		this.domNode.style.margin = "10px 0 0 10px";
		this.domNode.style.float = "left";

		document.body.appendChild(this.domNode);
	
	};
		
	HTML5DemoImageElementWrapper.prototype =
	{
		setStyle : function(elem) {
			elem.style = "float: both; margin-left: 0px; margin-top: 0px; width: 100px;";
		},

		setImage: function(imagePoolId) {
			
			var self = this;
			
			// Referencing an image that is configurable by the user of the control
			window.CDSWebVisuAccess.getImageById(imagePoolId).then(img => {
				self.setStyle(img);
				self.domNode.appendChild(img);
			}, reason => {
				console.log(reason);
			});
			
			// Referencing a static image using additional files
			window.CDSWebVisuAccess.getImageByFilename("Codesys_Logo.svg").then( (img) => {						
				self.setStyle(img);
				self.domNode.appendChild(img);
				}, reason => {
				console.log(reason);
			});
			
			// Referencing a static image using a data-uri
			var image = new Image();
			image.src = "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABQAAAAUCAYAAACNiR0NAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAABJSURBVDhPY/wPBAxUBExQmmqA6gaiepmREcogESAZQScXEhtPWNQP1UhBElIVhTKg4PZrKAMEhqSXR5MN5WCo5WUqgMEeKQwMADpbLgYzxxXsAAAAAElFTkSuQmCC";
			self.setStyle(image);
			self.domNode.appendChild(image);
		}
	};
}());

