var HTML5DemoTextfieldElementWrapper;

(function ()
{
	/* This HTML5 demo textfield control is used to demonstrate how different types of IEC 
	 * scalar values can be handled in both directions (read/write)
	 */
	HTML5DemoTextfieldElementWrapper = function()
	{
        this.parentNode = document.createElement("input");
		document.body.appendChild(this.parentNode);
		this._dataType = null;
		
		var self = this;
		this.parentNode.oninput = function() {
			var valueToSend, bCallCheckSimpleValue = true;
			if (self._dataType === 'string') {
				valueToSend = this.value;
			} else if (self._dataType === 'boolean') {
				bCallCheckSimpleValue = false;
				if (this.value === "false" || this.value === "true")
				{					
					valueToSend = this.value == "true";
					bCallCheckSimpleValue = true;
				}
			} else {
				valueToSend = Number(this.value);
			}
			if (bCallCheckSimpleValue)
				window.CDSWebVisuAccess.checkSimpleValue('setValue', valueToSend).then(()  => self.ValueOk(valueToSend), () => self.ValueNOk(valueToSend));
		};
		this.resizeObserver = new ResizeObserver(function() {
			
		}).observe(document.body);
	};
		
	HTML5DemoTextfieldElementWrapper.prototype =
	{
		ValueOk: function(value)
		{
			window.CDSWebVisuAccess.sendSimpleValue('setValue', value).then(() => console.log('Valid value ', value), () => console.log('Error writing ' + value));
		},
		
		ValueNOk: function(value)
		{
			// Do nothing
			console.log('Invalid value ', value);
		},
		
		setValue: function(value)
		{
			this._dataType = typeof value;
			this.parentNode.value = value;
		}
	};
}());

